//--------------------------------------------------------------//

//--------------------------------------------------------------//

//tB[h̐FiZj
float3 FieldColor = 0.5;//float3(0.5,1,1);
//F̋
float ColorPow = 2.0;
//c݂̋
float DistPow = 1;

//vZpeNX`TCY
#define TEX_SIZE 1024

//--悭킩Ȃl͂GȂ--//

float4x4 wvpmat 		: WorldViewProjection;
float4x4 WorldMatrix    : WORLD;
float4x4 wvmat          : WORLDVIEW;

float4   CameraPos     : POSITION   < string Object = "Camera"; >;
float3   LightDirection    : DIRECTION < string Object = "Light"; >;
float4   LightAmbient     : AMBIENT   < string Object = "Light"; >;
float4   LightDifuse     : DIFUSE   < string Object = "Light"; >;
float4   LightSpecular     : SPECULAR   < string Object = "Light"; >;
float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;

#define TEX_WIDTH TEX_SIZE
#define TEX_HEIGHT TEX_SIZE

//==================================================================================================
// eNX`[Tv[
//==================================================================================================

texture DistortionRT: OFFSCREENRENDERTARGET <
    string Description = "OffScreen RenderTarget for DistortionField.fx";
    int Width = TEX_SIZE;
    int Height = TEX_SIZE;
    float4 ClearColor = { 0, 0, 0, 1 };
    float ClearDepth = 1.0;
    bool AntiAlias = true;
    string DefaultEffect = 
        "self = hide;";
>;

sampler DistortionView = sampler_state {
    texture = <DistortionRT>;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};


//==================================================================================================
// _tH[}bg
//==================================================================================================

struct VS_OUTPUT
{
   float4 Pos      : POSITION;  //_W
   float3 Center      : TEXCOORD0; //@xNg
   float3 Eye		: TEXCOORD1;	//xNg
   float3 WPos      : TEXCOORD2;  //[hW
   float2 Tex		: TEXCOORD3;
   float2 CenterTex : TEXCOORD4;
};
float time_0_X : Time;

float4x4 view_proj_matrix : ViewProjection;

float3 CameraPosition : POSITION  < string Object = "Camera"; >;

//==================================================================================================
// _VF[_[
//==================================================================================================
VS_OUTPUT VS_SeaMain( float3 Pos      : POSITION,   //_W
              float3 normal   : NORMAL,     //@xNg
              float2 Tex      : TEXCOORD0   //eNZ
              )
{
	VS_OUTPUT Out;

	Out.Pos    = mul( float4( Pos, 1.0f ), wvpmat );
	Out.WPos   =mul( float4( Pos, 1.0f ), WorldMatrix );

	//@
	Out.Center =  float4(WorldMatrix[3].xyz,1);

	//xNg
	// JƂ̑Έʒu
	Out.Eye = normalize(CameraPosition - Out.WPos);

	//WVPϊςݍWXN[Wɕϊ
	float3 TgtPos = Out.Pos.xyz/Out.Pos.w;
	TgtPos.y *= -1;
	TgtPos.xy += 1;
	TgtPos.xy *= 0.5;
	
	Out.Tex = TgtPos.xy;
	
	float4 wc = mul( float4( 0,0,0, 1.0f ), wvpmat );
	
	TgtPos = wc.xyz/wc.w;
	TgtPos.y *= -1;
	TgtPos.xy += 1;
	TgtPos.xy *= 0.5;
	
	Out.CenterTex = TgtPos.xy;

	return Out;
}


//==================================================================================================
// sNZVF[_[ 
//==================================================================================================


float4 PS_SeaMain( VS_OUTPUT In ) : COLOR
{
	float3 normal = normalize(In.WPos.xyz - In.Center);
	
    float d = 1-abs(dot( normal, In.Eye ));

    
    //eNX`̃xNg
    float2 tex_vec = normalize(In.Tex - In.CenterTex);
    
    
	float4 col = tex2D(DistortionView,In.Tex + tex_vec*d*(DistPow * 0.1 * MaterialDiffuse.a)); 

	col.rgb -= (d*ColorPow)*(1-FieldColor)*MaterialDiffuse.a;
	
	return col;

}

#define BLENDMODE_SRC SRCALPHA
#define BLENDMODE_DEST INVSRCALPHA

//==================================================================================================
// eNjbN
//==================================================================================================
technique Technique_Sample
<
    string Script = 
        "RenderColorTarget0=;"
	    "RenderDepthStencilTarget=;"
	    "Pass=MainPath;"
    ;
> {
   //CpX 
   pass MainPath
   {
      ZENABLE = TRUE;
      ZWRITEENABLE = TRUE;
      CULLMODE = NONE;
      ALPHABLENDENABLE = TRUE;
      SRCBLEND=BLENDMODE_SRC;
      DESTBLEND=BLENDMODE_DEST;
      //gpVF[_ݒ
      VertexShader = compile vs_3_0 VS_SeaMain();
      PixelShader = compile ps_3_0 PS_SeaMain();
   }
	
}
